import { AsyncQuerySource, GroupedAsyncIterable } from "./interfaces";
export declare abstract class IterableBase<T> implements AsyncIterable<T> {
    protected readonly source: AsyncQuerySource<T>;
    constructor(source: AsyncQuerySource<T>);
    [Symbol.asyncIterator](): AsyncIterator<T, any, undefined>;
}
export declare class GroupedAsyncIterableImpl<TKey, TSource> extends IterableBase<TSource> implements GroupedAsyncIterable<TKey, TSource> {
    readonly key: TKey;
    constructor(key: TKey, core: AsyncIterable<TSource>);
}
