"use strict";
// Copyright 2016-2019, Pulumi Corporation.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
Object.defineProperty(exports, "__esModule", { value: true });
const sources_1 = require("./sources");
class IterableBase {
    constructor(source) {
        this.source = source;
    }
    [Symbol.asyncIterator]() {
        return sources_1.from(this.source)[Symbol.asyncIterator]();
    }
}
exports.IterableBase = IterableBase;
class GroupedAsyncIterableImpl extends IterableBase {
    constructor(key, core) {
        super(core);
        this.key = key;
    }
}
exports.GroupedAsyncIterableImpl = GroupedAsyncIterableImpl;
